#INCLUDE "dcdialog.CH"
#INCLUDE "outlook.CH"

#pragma Library("ascom10.lib")

FUNCTION Main()

LOCAL GetList[0], GetOptions, oOutlook, oNS, oContacts, nCurrent := 1, ;
      bGet, i, aContacts, oProgress

PRIVATE oContact

DC_LoadRdds()

oOutlook := CreateObject( "Outlook.Application" )
IF Empty(oOutLook)
  DC_WinAlert( "'Outlook.Application' can not be created:" + Chr(13) + Chr(10 ) +;
            ComLastMessage() , "Error" )
  QUIT
ENDIF

oNS := oOutlook:GetNamespace( "MAPI" )

oContacts := oNS:getDefaultFolder( olFolderContacts )
M->oContact := oContacts:items(nCurrent)

aContacts := { ;
   { 'Creation Time',              'CreationTime'                 }, ;
   { 'Last Modification Time',     'LastModificationTime'         }, ;
   { 'Email Address',              'Email1Address'                }, ;
   { 'Email Display Name',         'Email1DisplayName'            }, ;
   { 'Address City',               'BusinessAddressCity'          }, ;
   { 'Address Country',            'BusinessAddressCountry'       }, ;
   { 'Address Postal Code',        'BusinessAddressPostalCode'    }, ;
   { 'Address Post Office Box',    'BusinessAddressPostOfficeBox' }, ;
   { 'Address State',              'BusinessAddressState'         }, ;
   { 'Address Street',             'BusinessAddressStreet'        }, ;
   { 'Fax Number',                 'BusinessFaxNumber'            }, ;
   { 'Homepage',                   'BusinessHomepage'             }, ;
   { 'Telephone Number',           'BusinessTelephoneNumber'      }, ;
   { 'Callback Number',            'CallbackTelephoneNumber'      }, ;
   { 'Company Name',               'CompanyName'                  }, ;
   { 'First Name',                 'FirstName'                    }, ;
   { 'Middle Name',                'MiddleName'                   }, ;
   { 'Last Name',                  'LastName'                     }, ;
   { 'Job Title',                  'JobTitle'                     }, ;
   { 'Birthday',                   'Birthday'                     }, ;
   { 'Anniversary',                'Anniversary'                  }, ;
   { 'Assistant Name',             'AssistantName'                }, ;
   { 'Initials',                   'Initials'                     }, ;
   { 'Nickname',                   'Nickname'                     }, ;
   { 'Profession',                 'Profession'                   }, ;
   { 'Suffix',                     'Suffix'                       }, ;
   { 'Title',                      'Title'                        } }

FOR i := 1 TO Len(aContacts)
  bGet := &('{||Pad(DC_XtoC(M->oContact:' + aContacts[i,2] + '),50)}')
  @ i,0 DCSAY aContacts[i,1] GET bGet ;
        ;// KEYBLOCK {|a,b,o|o:undo()}

NEXT

@ i+.5, 5 DCPROGRESS oProgress COLOR GRA_CLR_BLUE PERCENT SIZE 70,1

@ i+2,25 DCPUSHBUTTON CAPTION 'Previous' SIZE 9,1.2 ;
      ACTION {||nCurrent--, M->oContact := oContacts:items(nCurrent), ;
                DC_GetRefresh(Getlist)} ;
      WHEN {|| nCurrent > 1 }

@ DCGUI_ROW, DCGUI_COL + 20 DCPUSHBUTTON CAPTION 'Next' SIZE 9,1.2 ;
      ACTION {||nCurrent++, M->oContact := oContacts:items(nCurrent), ;
                DC_GetRefresh(Getlist)} ;
      WHEN {|| nCurrent < oContacts:items:count }

@ DCGUI_ROW, DCGUI_COL + 20 DCPUSHBUTTON CAPTION 'Import' SIZE 9,1.2 ;
      ACTION {|| ExportItems(oContacts, oProgress)}

DCGETOPTIONS ;
   SAYRIGHTBOTTOM ;
   SAYWIDTH 150

DCREAD GUI ;
   FIT ;
   OPTIONS GetOptions ;
   TITLE 'Outlook Contacts'

RETURN nil

* -------------

STATIC FUNCTION ExportItems( oContacts, oProgress )
LOCAL GetList[0] // Jimmy
LOCAL aStruct := {}, nA, oContact, nOldCurr, cDbfFile, nCurrent := 1
LOCAL iMax
LOCAL bSaveError, oError

cDbfFile := "OUTLOOK"

aStruct := { ;
  {"EMAIL1ADDR", "C", 50, 0}, ;
  {"FIRSTNAME",  "C", 50, 0}, ;
  {"MIDDLENAME", "C", 50, 0}, ;
  {"LASTNAME",   "C", 50, 0}, ;
  {"JOBTITLE",   "C", 50, 0}, ;
  {"CREATETIME", "D",  0, 0}, ;
  {"BIRTHDAY",   "D",  0, 0}, ;
  {"LASTMODTIM", "D",  0, 0}, ;
  {"ANNIVERSAR", "D",  0, 0}, ;
  {"ASSISTANTN", "C", 50, 0}, ;
  {"EMAIL1DISP", "C", 50, 0}, ;
  {"INITIALS",   "C", 50, 0}, ;
  {"NICKNAME",   "C", 50, 0}, ;
  {"PROFESSION", "C", 50, 0}, ;
  {"SUFFIX",     "C", 50, 0}, ;
  {"BADDRCITY",  "C", 50, 0}, ;
  {"BADDRCOUNT", "C", 50, 0}, ;
  {"BADDRPOST",  "C", 50, 0}, ;
  {"BADDRPOSTB", "C", 50, 0}, ;
  {"BADDRSTATE", "C", 50, 0}, ;
  {"BADDRSTREE", "C", 50, 0}, ;
  {"BADDRFAXNU", "C", 50, 0}, ;
  {"BADDRHOMEP", "C", 50, 0}, ;
  {"BADDRTELNU", "C", 50, 0}, ;
  {"CALLBACKTE", "C", 50, 0}, ;
  {"COMPANYNAM", "C", 50, 0}, ;
  {"TITLE",      "C", 50, 0} }


  // Create a new database file. Delete the old one if any.
IF File( cDBFFile + ".DBF" )
  FErase( cDBFFile  + ".DBF" )
ENDIF
DBCreate( cDBFFile, aStruct, "FOXCDX" )
DbCloseAll()
DbUseArea( .T., 'FOXCDX', cDBFFile, , .F. )

nA := Select()

// Jimmy:call once
//
iMax := oContacts:items:count

#IFDEF DXE
   // Jimmy:need for right Scale
   //
   oProgress:nScaleMax := iMax*(iMax/100)
#ENDIF

// Jimmy:add Errorblock
//
bSaveError := ErrorBlock()

DO WHILE nCurrent++ < iMax

  DC_GetProgress( oProgress, nCurrent, iMax )

  oContact := oContacts:items(nCurrent)

  ( nA )->( DbAppend() )

   ErrorBlock( {|e| Break(e)} )

   BEGIN SEQUENCE

  ( nA )->BADDRCITY   :=  oContact:BusinessAddressCity
  ( nA )->BADDRCOUNT  :=  oContact:BusinessAddressCountry
  ( nA )->BADDRPOST   :=  oContact:BusinessAddressPostalCode
  ( nA )->BADDRPOSTB  :=  oContact:BusinessAddressPostOfficeBox
  ( nA )->BADDRSTATE  :=  oContact:BusinessAddressState
  ( nA )->BADDRSTREE  :=  oContact:BusinessAddressStreet
  ( nA )->BADDRFAXNU  :=  oContact:BusinessFaxNumber
  ( nA )->BADDRHOMEP  :=  oContact:BusinessHomePage
  ( nA )->BADDRTELNU  :=  oContact:BusinessTelephoneNumber
  ( nA )->CALLBACKTE  :=  oContact:CallbackTelephoneNumber
  ( nA )->COMPANYNAM  :=  oContact:CompanyName
  ( nA )->EMAIL1ADDR  :=  oContact:Email1Address
  ( nA )->FIRSTNAME   :=  oContact:FirstName
  ( nA )->MIDDLENAME  :=  oContact:MiddleName
  ( nA )->LASTNAME    :=  oContact:LastName
  ( nA )->JOBTITLE    :=  oContact:JobTitle
  ( nA )->CREATETIME  :=  oContact:CreationTime
  ( nA )->BIRTHDAY    :=  oContact:Birthday
  ( nA )->LASTMODTIM  :=  oContact:LastModificationTime
  ( nA )->ANNIVERSAR  :=  oContact:Anniversary
  ( nA )->ASSISTANTN  :=  oContact:AssistantName
  ( nA )->EMAIL1DISP  :=  oContact:Email1DisplayName
  ( nA )->INITIALS    :=  oContact:Initials
  ( nA )->NICKNAME    :=  oContact:NickName
  ( nA )->PROFESSION  :=  oContact:Profession
  ( nA )->SUFFIX      :=  oContact:Suffix
  ( nA )->TITLE       :=  oContact:Title

   // Jimmy: how to refresh ?
   //
   * DC_GetRefresh(Getlist)

   RECOVER USING oError
      ErrorBlock( bSaveError )

   END SEQUENCE

ENDDO

( nA )->( DbCloseArea() )

ErrorBlock( bSaveError )

#IFDEF DXE
   // Jimmy:reset Progressbar or destroy it
   //
   oProgress:SetData(0)
#ENDIF

RETURN nil


* ---------------

PROC appsys
RETURN


